BoiunaSite/Controllers/AdminAnalisarController.cs
using System.Linq;
using Infraestrutura;
using Infraestrutura.Modelos;
using Infraestrutura.ViewModels;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;

namespace BoiunaSite.Controllers
{
    public class AdminAnalisarController : Controller
    {
        private readonly Contexto _contexto;
        private readonly DbSet<InscriçãoMinecraftModelo> _dadosMinecraft;
        private readonly DbSet<InscriçãoHackathonModelo> _dadosHackathon;

        public AdminAnalisarController(Contexto contexto)
        {
            _contexto = contexto;
            _dadosMinecraft = _contexto.Set<InscriçãoMinecraftModelo>();
            _dadosHackathon = _contexto.Set<InscriçãoHackathonModelo>();
        }

        [Authorize(Roles = "Admin")]
        public IActionResult Minecraft()
        {
            var inscrições = _dadosMinecraft.OrderBy(m => m.Id)
                .Include(m => m.Cadastro)
                .Select(m => new AdminInscriçãoMinecraftViewModel<CadastroModelo>(m))
                .ToList();

            return View("ListarMine", inscrições);
        }

        [Authorize(Roles = "Admin")]
        public IActionResult Hackathon()
        {
            var inscrições = _dadosHackathon.OrderBy(h => h.Id)
                .Include(h => h.Cadastro)
                .Select(h => new AdminInscriçãoMinecraftViewModel<CadastroModelo>(h))
                .ToList();

            return View("ListarHackathon", inscrições);
        }

        [Authorize(Roles = "Admin")]
        [HttpGet("{controller}/{action}/{id}")]
        public IActionResult AnalisarMinecraft(int id)
        {
            var modelo = _dadosMinecraft.Where(m => m.Id == id)
                .Include(m => m.Cadastro)
                .SingleOrDefault();

            var viewModel = new AnalisarInscriçãoMinecraftViewModel<CadastroModelo>(modelo);
            return View(viewModel);
        }

        [Authorize(Roles = "Admin")]
        [HttpGet("{controller}/{action}/{id}")]
        public IActionResult AnalisarHackathon(int id)
        {
            var modelo = _dadosHackathon.Where(h => h.Id == id)
                .Include(h => h.Cadastro)
                .SingleOrDefault();

            var viewModel = new AnalisarInscriçãoHackathonViewModel<CadastroModelo>(modelo);
            return View(viewModel);
        }
    }
}

BoiunaSite/Controllers/ArquivosUploadsController.cs
using System.Linq;
using Infraestrutura;
using Infraestrutura.Modelos;
using Infraestrutura.Modelos.Interfaces;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;

namespace BoiunaSite.Controllers
{
    public class ArquivosUploadsController : Controller
    {

        private readonly Contexto _contexto;
        private readonly DbSet<CadastroModelo> _dadosCadastro;

        public ArquivosUploadsController(Contexto contexto)
        {
            _contexto = contexto;
            _dadosCadastro = _contexto.Set<CadastroModelo>();
        }

        [Authorize(Roles = "Admin")]
        [HttpGet("{controller}/{action}/{id}")]
        public IActionResult MostrarRGCPF(int id)
        {
            var caminho = ObterCaminhoRGCPF(id);
            var bytes = RetornarArquivo(caminho);
            return File(bytes, "application/pdf");
        }

        [Authorize(Roles = "Admin")]
        [HttpGet("{controller}/{action}/{id}")]
        public IActionResult MostrarComprovante(int id)
        {
            var caminho = ObterCaminhoComprovante(id);
            var bytes = RetornarArquivo(caminho);
            return File(bytes, "application/pdf");
        }

        [Authorize(Roles = "Admin")]
        [HttpGet("{controller}/{action}/{id}")]
        public IActionResult MostrarComprovanteBanco(int id)
        {
            var caminho = ObterCaminhoComprovanteBancário(id);
            var bytes = RetornarArquivo(caminho);
            return File(bytes, "application/pdf");
        }

        [Authorize(Roles = "Admin")]
        [HttpGet("{controller}/{action}/{id}")]
        public IActionResult MostrarDeclaraçãoResidência(int id)
        {
            var caminho = ObterCaminhoDeclaraçãoResidência(id);
            var bytes = RetornarArquivo(caminho);
            return File(bytes, "application/pdf");
        }

        [Authorize(Roles = "Admin")]
        [HttpGet]
        public IActionResult MostrarRGCPFResponsavel(int id)
        {
            var caminho = ObterCaminhoRFCPFResponsável(id);
            var bytes = RetornarArquivo(caminho);
            return File(bytes, "application/pdf");
        }

        [Authorize(Roles = "Admin")]
        [HttpGet]
        public IActionResult MostrarSelfieResponsavel(int id)
        {
            var caminho = ObterCaminhoSelfieResponsável(id);
            var bytes = RetornarArquivo(caminho);
            return File(bytes, $"image/{Extensão(caminho)}");
        }

        [Authorize(Roles = "Admin")]
        [HttpGet]
        public IActionResult MostrarSelfie(int id)
        {
            var caminho = ObterCaminhoSelfie(id);
            var bytes = RetornarArquivo(caminho);
            return File(bytes, $"image/{Extensão(caminho)}");
        }

        [Authorize(Roles = "Admin")]
        [HttpGet]
        public IActionResult MostrarFoto(int id)
        {
            var caminho = ObterCaminhoFoto(id);
            var bytes = RetornarArquivo(caminho);
            return File(bytes, $"image/{Extensão(caminho)}");
        }

        private string ObterCaminhoFoto(int id) => ObterCadastro(id).CaminhoFoto;
        private string ObterCaminhoSelfie(int id) => ObterCadastro(id).CaminhoFoto;
        private string Extensão(string caminho) => caminho.Split(".").Last();
        private string ObterCaminhoSelfieResponsável(int id) => ObterCadastro(id).CaminhoFotoResponsável;
        private string ObterCaminhoRFCPFResponsável(int id) => ObterCadastro(id).CaminhoRGCPFResponsável;
        private byte[] RetornarArquivo(string caminho) => System.IO.File.ReadAllBytes(caminho);
        private string ObterCaminhoRGCPF(int id) => ObterCadastro(id).CaminhoRGCPF;
        private string ObterCaminhoComprovante(int id) => ObterCadastro(id).CaminhoComprovanteEndereço;
        private string ObterCaminhoComprovanteBancário(int id) => ObterCadastro(id).CaminhoComprovanteBancário;
        private string ObterCaminhoDeclaraçãoResidência(int id) => ObterCadastro(id).CaminhoDeclaraçãoDeResidência;
        private ICadastroModelo ObterCadastro(int id) => _dadosCadastro.Where(c => c.Id == id).SingleOrDefault();
    }
}

BoiunaSite/Controllers/DeferirController.cs
using System.Linq;
using Infraestrutura;
using Infraestrutura.Modelos;
using Infraestrutura.Modelos.Interfaces;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;

namespace BoiunaSite.Controllers
{
    public class DeferirController : Controller
    {

        private readonly Contexto _contexto;
        private readonly DbSet<InscriçãoMinecraftModelo> _dadosMinecraft;
        private readonly DbSet<InscriçãoHackathonModelo> _dadosHackathon;

        public DeferirController(Contexto contexto)
        {
            _contexto = contexto;
            _dadosMinecraft = _contexto.Set<InscriçãoMinecraftModelo>();
            _dadosHackathon = _contexto.Set<InscriçãoHackathonModelo>();
        }

        [Authorize(Roles = "Admin")]
        [HttpGet("{controller}/{action}/{id}")]
        public IActionResult DeferirMinecraft(int id)
        {
            var inscrição = MinecraftPorId(id);
            Deferir(inscrição);
            AtualizarMinecraft(inscrição);

            return View("Sucesso");
        }

 

        [Authorize(Roles = "Admin")]
        [HttpGet]
        public IActionResult IndeferirMinecraft(int id)
        {
            var inscrição = MinecraftPorId(id);
            Indeferir(inscrição);
            AtualizarMinecraft(inscrição);

            return View("Sucesso");
        }

        [Authorize(Roles = "Admin")]
        [HttpGet("{controller}/{action}/{id}")]
        public IActionResult DeferirHackathon(int id)
        {
            var inscrição = HackathonPorId(id);
            Deferir(inscrição);
            AtualizarHackathon(inscrição);

            return View("Sucesso");
        }

        [Authorize(Roles = "Admin")]
        [HttpGet]
        public IActionResult IndeferirHackathon(int id)
        {
            var inscrição = HackathonPorId(id);
            Indeferir(inscrição);
            AtualizarHackathon(inscrição);

            return View("Sucesso");
        }

        private void Deferir(IInscriçãoModelo<CadastroModelo> inscrição)
        {
            inscrição.Análise = false;
            inscrição.Aprovada = true;
        }

        private void Indeferir(IInscriçãoModelo<CadastroModelo> inscrição)
        {
            inscrição.Análise = false;
            inscrição.Aprovada = false;
        }

        private InscriçãoMinecraftModelo MinecraftPorId(int id) => _dadosMinecraft.Where(m => m.Id == id).SingleOrDefault();
        private InscriçãoHackathonModelo HackathonPorId(int id) => _dadosHackathon.Where(h => h.Id == id).SingleOrDefault();

        private void AtualizarMinecraft(InscriçãoMinecraftModelo inscrição)
        {
            _dadosMinecraft.Update(inscrição);
            _contexto.SaveChanges();
        }

        private void AtualizarHackathon(InscriçãoHackathonModelo hackathon)
        {
            _dadosHackathon.Update(hackathon);
            _contexto.SaveChanges();
        }

    }
}

BoiunaSite/Views/AdminAnalisar/AnalisarHackathon.cshtml
@model Infraestrutura.ViewModels.AnalisarInscriçãoHackathonViewModel<Infraestrutura.Modelos.CadastroModelo>;

    <div class="container">
        <div class="jumbotron bg-light rounded p-2">
            <div class="row">
                <div class="col-sm-6">
                    <a asp-controller="ArquivosUploads" asp-action="MostrarSelfie" asp-route-id="@Model.CadastroId" target="_blank">
                        <img src="@Url.Action("MostrarFoto", "ArquivosUploads", new { id = Model.CadastroId })" class="img-fluid"/>
                    </a>
                </div>
                <div class="col-sm-6 my-auto">
                    <h2>Dados Pessoais</h2>
                    <div class="row mb-2">
                        <div class="col" 0>
                            <font class="font-weight-bold">Nome: </font>@Model.Nome
                        </div>
                    </div>

                    <div class="row mb-2">
                        <div class="col">
                            <font class="font-weight-bold">CPF: </font>@Model.CPF
                        </div>
                        <div class="col">
                            <font class="font-weight-bold">Telefone: </font>@Model.Telefone
                        </div>
                    </div>

                    <div class="row mb-2">
                        <div class="col">
                            <font class="font-weight-bold">E-mail: </font>@Model.Email
                        </div>
                    </div>

                    <div class="row mb-2">
                        <div class="col">
                            <font class="font-weight-bold">Endereço: </font>@Model.Endereço
                        </div>
                    </div>

                    <div class="row mb-2">
                        <div class="col">
                            <font class="font-weight-bold">Cidade: </font>@Model.Cidade
                        </div>
                        <div class="col">
                            <font class="font-weight-bold">CEP: </font>@Model.CEP
                        </div>
                    </div>

                    <div class="row mb-2">
                        <div class="col">
                            <font class="font-weight-bold">Banco: </font>@Model.Banco
                        </div>
                    </div>
                    <div class="row mb-2">
                        <div class="col">
                            <font class="font-weight-bold">Agência: </font>@Model.Agência
                        </div>
                        <div class="col">
                            <font class="font-weight-bold">Conta: </font>@Model.Conta
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="jumbotron bg-dark text-white rounded p-2">
            <h2>Documentos</h2>

            <div class="row">
                <div class="col">
                    <a class="btn btn-info" asp-controller="ArquivosUploads" asp-action="MostrarRGCPF" asp-route-id="@Model.CadastroId" target="_blank">RG e CPF</a>
                    <a class="btn btn-info" asp-controller="ArquivosUploads" asp-action="MostrarComprovante" asp-route-id="@Model.CadastroId" target="_blank">Comprovante de Residência</a>
                    <a class="btn btn-info" asp-controller="ArquivosUploads" asp-action="MostrarComprovanteBanco" asp-route-id="@Model.CadastroId" target="_blank">Comprovante Bancário</a>

                    @if (Model.TemDeclaração)
                    {
                        <a class="btn btn-info" asp-controller="ArquivosUploads" asp-action="MostrarDeclaraçãoResidência" asp-route-id="@Model.CadastroId" target="_blank">Declaração de Residência</a>
                    }
                </div>
            </div>
        </div>

        @if (Model.TemResponsável)
        {
            <div class="jumbotron bg-light rounded p-2">
                <h2>Dados Do Responsável</h2>

                <div class="row">
                    <div class="col my-auto">
                        <font class="font-weight-bold">Nome: </font>@Model.NomeResponsável
                    </div>
                    <div class="col my-auto">
                        <font class="font-weight-bold">CPF: </font>@Model.CPFResponsável
                    </div>
                    <div class="col">
                        <a class="btn btn-info" asp-controller="ArquivosUploads" asp-action="MostrarRGCPFResponsavel" asp-route-id="@Model.CadastroId" target="_blank">RG e CPF</a>
                        <a class="btn btn-info" asp-controller="ArquivosUploads" asp-action="MostrarSelfieResponsavel" asp-route-id="@Model.CadastroId" target="_blank">Selfie</a>
                    </div>
                </div>
            </div>
        }

        <div class="jumbotron bg-dark text-white rounded p-2">
            <h2>Dados da Inscrição</h2>

            <div class="row">
                <div class="col">
                    <font class="font-weight-bold">Nome da Equipe: </font>@Model.NomeDaEquipe
                </div>
            </div>
            <div class="row">
                <div class="col">
                    <font class="font-weight-bold">Membros: </font>@Model.Membros
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col">
                <a class="btn btn-danger"  asp-controller="Deferir" asp-action="IndeferirHackathon" asp-route-id="@Model.Id">Indeferir</a>
                <a class="btn btn-success" asp-controller="Deferir" asp-action="DeferirHackathon" asp-route-id="@Model.Id">Deferir</a>
            </div>
        </div>
    </div>

BoiunaSite/Views/AdminAnalisar/AnalisarMinecraft.cshtml
@model Infraestrutura.ViewModels.AnalisarInscriçãoMinecraftViewModel<Infraestrutura.Modelos.CadastroModelo>;

    <div class="container">
        <div class="jumbotron bg-light rounded p-2">
            <div class="row">
                <div class="col-sm-6">
                    <a asp-controller="ArquivosUploads" asp-action="MostrarSelfie" asp-route-id="@Model.CadastroId" target="_blank">
                        <img src="@Url.Action("MostrarFoto", "ArquivosUploads", new { id = Model.CadastroId })" class="img-fluid"/>
                    </a>
                </div>
                <div class="col-sm-6 my-auto">
                    <h2>Dados Pessoais</h2>
                    <div class="row mb-2">
                        <div class="col" 0>
                            <font class="font-weight-bold">Nome: </font>@Model.Nome
                        </div>
                    </div>

                    <div class="row mb-2">
                        <div class="col">
                            <font class="font-weight-bold">CPF: </font>@Model.CPF
                        </div>
                        <div class="col">
                            <font class="font-weight-bold">Telefone: </font>@Model.Telefone
                        </div>
                    </div>

                    <div class="row mb-2">
                        <div class="col">
                            <font class="font-weight-bold">E-mail: </font>@Model.Email
                        </div>
                    </div>

                    <div class="row mb-2">
                        <div class="col">
                            <font class="font-weight-bold">Endereço: </font>@Model.Endereço
                        </div>
                    </div>

                    <div class="row mb-2">
                        <div class="col">
                            <font class="font-weight-bold">Cidade: </font>@Model.Cidade
                        </div>
                        <div class="col">
                            <font class="font-weight-bold">CEP: </font>@Model.CEP
                        </div>
                    </div>

                    <div class="row mb-2">
                        <div class="col">
                            <font class="font-weight-bold">Banco: </font>@Model.Banco
                        </div>
                    </div>
                    <div class="row mb-2">
                        <div class="col">
                            <font class="font-weight-bold">Agência: </font>@Model.Agência
                        </div>
                        <div class="col">
                            <font class="font-weight-bold">Conta: </font>@Model.Conta
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="jumbotron bg-dark text-white rounded p-2">
            <h2>Documentos</h2>

            <div class="row">
                <div class="col">
                    <a class="btn btn-info" asp-controller="ArquivosUploads" asp-action="MostrarRGCPF" asp-route-id="@Model.CadastroId" target="_blank">RG e CPF</a>
                    <a class="btn btn-info" asp-controller="ArquivosUploads" asp-action="MostrarComprovante" asp-route-id="@Model.CadastroId" target="_blank">Comprovante de Residência</a>
                    <a class="btn btn-info" asp-controller="ArquivosUploads" asp-action="MostrarComprovanteBanco" asp-route-id="@Model.CadastroId" target="_blank">Comprovante Bancário</a>

                    @if (Model.TemDeclaração)
                    {
                        <a class="btn btn-info" asp-controller="ArquivosUploads" asp-action="MostrarDeclaraçãoResidência" asp-route-id="@Model.CadastroId" target="_blank">Declaração de Residência</a>
                    }
                </div>
            </div>
        </div>

        @if (Model.TemResponsável)
        {
            <div class="jumbotron bg-light rounded p-2">
                <h2>Dados Do Responsável</h2>

                <div class="row">
                    <div class="col my-auto">
                        <font class="font-weight-bold">Nome: </font>@Model.NomeResponsável
                    </div>
                    <div class="col my-auto">
                        <font class="font-weight-bold">CPF: </font>@Model.CPFResponsável
                    </div>
                    <div class="col">
                        <a class="btn btn-info" asp-controller="ArquivosUploads" asp-action="MostrarRGCPFResponsavel" asp-route-id="@Model.CadastroId" target="_blank">RG e CPF</a>
                        <a class="btn btn-info" asp-controller="ArquivosUploads" asp-action="MostrarSelfieResponsavel" asp-route-id="@Model.CadastroId" target="_blank">Selfie</a>
                    </div>
                </div>
            </div>
        }

        <div class="jumbotron bg-dark text-white rounded p-2">
            <h2>Dados da Inscrição</h2>

            <div class="row">
                <div class="col">
                    <font class="font-weight-bold">Nickname: </font>@Model.Nickname
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col">
                <a class="btn btn-danger"  asp-controller="Deferir" asp-action="IndeferirMinecraft" asp-route-id="@Model.Id">Indeferir</a>
                <a class="btn btn-success" asp-controller="Deferir" asp-action="DeferirMinecraft" asp-route-id="@Model.Id">Deferir</a>
            </div>
        </div>
    </div>

BoiunaSite/Views/AdminAnalisar/ListarHackathon.cshtml
@model List<Infraestrutura.ViewModels.AdminInscriçãoMinecraftViewModel<Infraestrutura.Modelos.CadastroModelo>>

<h1 class="display-4">Inscrições</h1>

<table class="table">
    <thead>
        <tr>
            <th scope="col">#</th>
            <th scope="col">Nome</th>
            <th scope="col">Ações</th>
            <th scope="col">Status</th>
        </tr>
    </thead>
    <tbody>
        @for (int i = 1; i <= Model.Count; i++)
        {
        <tr>
            <th scope="row">@i</th>
            <td>@Model[i-1].Nome</td>
            <td><a class="btn btn-success" asp-controller="AdminAnalisar" asp-action="AnalisarHackathon" asp-route-id="@Model[i-1].Id">Analisar Inscrição</a></td>
            <td><span class="badge @Model[i-1].ClasseStatus">@Model[i-1].Status</span></td>
        </tr>
        }
    </tbody>
</table>

BoiunaSite/Views/AdminAnalisar/ListarMine.cshtml
@model List<Infraestrutura.ViewModels.AdminInscriçãoMinecraftViewModel<Infraestrutura.Modelos.CadastroModelo>>

<h1 class="display-4">Inscrições</h1>

<table class="table">
    <thead>
        <tr>
            <th scope="col">#</th>
            <th scope="col">Nome</th>
            <th scope="col">Ações</th>
            <th scope="col">Status</th>
        </tr>
    </thead>
    <tbody>
        @for (int i = 1; i <= Model.Count; i++)
        {
        <tr>
            <th scope="row">@i</th>
            <td>@Model[i-1].Nome</td>
            <td><a class="btn btn-success" asp-controller="AdminAnalisar" asp-action="AnalisarMinecraft" asp-route-id="@Model[i-1].Id">Analisar Inscrição</a></td>
            <td><span class="badge @Model[i-1].ClasseStatus">@Model[i-1].Status</span></td>
        </tr>
        }
    </tbody>
</table>

BoiunaSite/Views/AdminAnalisar/Logar.cshtml
@model Infraestrutura.ViewModels.EntrarViewModel;

<h1 class="display-4">Entrar</h1>

@if (Model.Validação.Erro)
{
    <div class="alert alert-danger" role="alert" id="Erros">
        @Model.Validação.MensagemErro
    </div>
}
else
{
    <div class="alert alert-danger d-none" role="alert" id="Erros">
        @Model.Validação.MensagemErro
    </div>
}


<form asp-antiforgery="true" asp-action="FazerLogin" method="post">
    <div class="form-group">
        <label for="Email">E-mail</label>
        <input type="email" class="form-control" id="Email" asp-for="Email" required>
    </div>
    <div class="form-group">
        <label for="Senha">Senha</label>
        <input type="password" class="form-control" id="Senha" asp-for="Senha" required>
    </div>
    <button type="submit" class="btn btn-primary">Entrar</button>
</form>